Option Explicit

#include ..\lib\framework_domotics.vbs
#include local-parameters.inc

Sub main
Dim astrDevices
Dim astrConfig
Dim astrTemplateStart
Dim astrTemplateStop
Dim astrMode
Dim atabDv
Dim astrNbDv
Dim astrFileNameStart
Dim astrFileNameStop
Dim astrFullFileNameStart
Dim astrFullFileNameStop
Dim i
Dim astrLettre
Dim astrCode
Dim astrName
Dim astrPARAM1
Dim astrPARAM2
Dim astrPARAM3
Dim astrPARAM4
Dim astrBuffer
Dim astrTmpFileNameStart
Dim astrTmpFileNameStop
Dim astrRUN
Dim astrCMD
Dim astrOPTIONS
Dim astrTmpFolder

LoadPropertyFile G_FOLDER_NAME, G_FILE_INI
If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then
	WriteLog G_FOLDER_NAME, G_SCRIPT_INS, G_TIV_INF, "Devices created", G_LOG_FILE
	astrDevices 		= hs.GetINISetting("COMMON","SOFTS","", G_FILE_INI)
	astrConfig  		= hs.GetINISetting("COMMON","CONFIG","..\scripts\modules\MONITOR.SOFTWARE\", G_FILE_INI)
	astrFileNameStart	= hs.GetINISetting("COMMON","TEMPLATE_START","", G_FILE_INI)
	astrFileNameStop	= hs.GetINISetting("COMMON","TEMPLATE_STOP","", G_FILE_INI)
	astrMode			= hs.GetINISetting("COMMON","MODE",G_ALONE,G_FILE_INI)
	astrTmpFolder       = hs.GetINISetting("COMMON","TMP_FOLDER",G_ALONE,G_FILE_INI)
	atabDv	 			= Split(astrDevices, G_SEP)
	astrNbDv 			= UBound(atabDv) 
	astrFullFileNameStart	= extendFileName(astrConfig & astrFileNameStart)
	astrFullFileNameStop	= extendFileName(astrConfig & astrFileNameStop)

	If isFileExist(astrFullFileNameStart) And isFileExist(astrFullFileNameStop) Then
		WriteLog G_FOLDER_NAME, G_SCRIPT_INS, G_TIV_INF, "Trying to load " & astrFileNameStart & _
                     " and " & astrFileNameStop, G_LOG_FILE
		astrTemplateStart 	= LoadFile(astrFullFileNameStart, False)
		astrTemplateStop	= LoadFile(astrFullFileNameStop,  False)
		WriteLog G_FOLDER_NAME, G_SCRIPT_INS, G_TIV_INF, "Templates loaded", G_LOG_FILE
		i=0
		While (i <= Cint(astrNbDv))
			astrLettre 		= hs.GetINISetting("DEVICE", "HC",     "", astrConfig & atabDv(i)) 
			astrCode 		= hs.GetINISetting("DEVICE", "DC",     "", astrConfig & atabDv(i))
			astrName 		= hs.GetINISetting("DEVICE", "NAME",   "", astrConfig & atabDv(i))
			astrPARAM1 		= hs.GetINISetting("DEVICE", "PARAM1", "", astrConfig & atabDv(i))
			astrPARAM2 		= hs.GetINISetting("DEVICE", "PARAM2", "", astrConfig & atabDv(i))
			astrPARAM3 		= hs.GetINISetting("DEVICE", "PARAM3", "", astrConfig & atabDv(i))
			astrPARAM4 		= hs.GetINISetting("DEVICE", "PARAM4", "", astrConfig & atabDv(i))

'---------- CREATE A EVENT IF THE DEVICE CAN BE STARTED MANUALLY
            astrBuffer  = replace(astrTemplateStart,"##DEVICE##",astrLettre & astrCode)
            astrBuffer  = replace(astrBuffer,"##NAME##",astrName)
            astrTmpFileNameStart = replace(astrTmpFolder & astrFileNameStart,"##DEVICE##",astrLettre & astrCode)
			If (astrPARAM3 <> "") and Not(isFileExist(astrTmpFileNameStart)) Then
                SaveINIFile astrTmpFileNameStart, astrBuffer, "EVENT"
                CheckAndCreateEvent astrTmpFileNameStart, astrMode
                WriteLog G_FOLDER_NAME, G_SCRIPT_INS, G_TIV_INF,astrLettre & astrCode & " Evt saved (start)", G_LOG_FILE
			End if

'---------- CREATE A EVENT IF THE DEVICE CAN BE STOPPED MANUALLY
            astrBuffer  = replace(astrTemplateStop,"##DEVICE##",astrLettre & astrCode)
            astrBuffer  = replace(astrBuffer,"##NAME##",astrName)
            astrTmpFileNameStop = replace(astrTmpFolder & astrFileNameStop,"##DEVICE##",astrLettre & astrCode)
			If (astrPARAM4 <> "") and Not(isFileExist(astrTmpFileNameStop))  Then
                SaveINIFile astrTmpFileNameStop, astrBuffer, "EVENT"
                CheckAndCreateEvent astrTmpFileNameStop, astrMode
                WriteLog G_FOLDER_NAME, G_SCRIPT_INS, G_TIV_INF,astrLettre & astrCode & " Evt saved (stop)", G_LOG_FILE
			End if
        
'---------- CHECK or CREATE BAT FILE FOR RECCURING EVENT
            astrRUN  = G_TMP_FOLDER & UCASE(astrPARAM2) & "_" & UCASE(astrPARAM1)& ".bat"
            If (UCASE(astrPARAM2) = "USEDRAM") and Not(isFileExist(astrRUN)) Then
                astrOPTIONS = """ -m > """ & G_TMP_FOLDER & astrPARAM1 & ".txt"
                astrCMD = """" & G_PS_PROG & astrOPTIONS & """"
                astrRUN = generateBatFile(astrCMD, UCASE(astrPARAM2) & "_" & UCASE(astrPARAM1))    
            End if
			i = i + 1
		Wend
		
	Else
		WriteLog G_FOLDER_NAME, G_SCRIPT_INS, G_TIV_INF, astrFileNameStart & " and " & astrFileNameStop & " do not exist", G_LOG_FILE		
	End if
End if
WriteLog G_FOLDER_NAME, G_SCRIPT_INS, G_TIV_INF, G_FOLDER_NAME & " installed.", G_LOG_FILE
End Sub
